/**
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 */
package com.sunlabs.archsim.fleet.ships.fetchAndIssue;

import com.sunlabs.archsim.base.simulation.Delay;

/**
 * @author ib27688
 *
 */
public class FetchAndIssueDefaults {

	private FetchAndIssueDefaults() {}
	
	public static final String INSTRUCTION_OUT= "InstructionOut";
	public static final String ACK_INSTRUCTION_OUT= "ackInstructionOut";

	public static final String LITERAL_OUT= "LiteralOut";
	public static final String ACK_LITERAL_OUT= "ackLiteralOut";
	
	public static final String INSTRUCTION_ISSUE_DELAY= "instructionIssueDelay";
	public static final Delay INSTRUCTION_ISSUE_DELAY_DEF= new Delay(10);
	
	public static final String LITERAL_ISSUE_DELAY= "literalIssueDelay";
	public static final Delay LITERAL_ISSUE_DELAY_DEF= new Delay(10);
	
	public static final String FETCH_ACK_DELAY= "fetchDelay";
	public static final Delay FETCH_ACK_DELAY_DEF= new Delay(20);
	
} // FetchAndIssueDefaults
