/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Feb 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.sunlabs.archsim.tests.splitter;

import java.util.Iterator;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.Terminal;

/**
 * @author ib27688
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SplitterAction extends Action {
	
	public SplitterAction(String name) {
		super(name);
		outputFunctions.put(SplitterGlobal.SPLIT_BITS_OUT_TERMINAL_NAME, 
						new SplitBitsFunction());
		outputFunctions.put(SplitterGlobal.REMAINDER_OUT_TERMINAL_NAME, 
				new RemainderFunction());
	} // SplitAction
	
	private class SplitBitsFunction extends Function {
		
		public SplitBitsFunction() {
			super("SplitBits");
			functionDelay= new Delay(10);
		} // SplitBits function
		
		public Object value() {
			Iterator ti= terminals.iterator();
			boolean found= false;
			Terminal t= null;
			while (!found && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName() == SplitterGlobal.DATA_IN_TERMINAL_NAME) {
					found= true;
				}
			}
			if (found) {
				// get the data from 
				int[] bitsIn= (int[]) t.getData();
				int[] splitBits= new int[SplitterGlobal.bitsToSplit];
				for (int i= 0; i< SplitterGlobal.bitsToSplit; i++) {
					splitBits[i]= bitsIn[i];
				}
				return splitBits;
			}
			else {
				director.journal("ERROR: function " + getName()
						+ " could not found terminal "
						+ SplitterGlobal.DATA_IN_TERMINAL_NAME
						+ " attached to action "
						+ SplitterAction.this.getName() + ", id= "
						+ SplitterAction.this.getID());
				director.stop();
				return null;
			}
		} // value
	} // SplitBitsFunction
	
	
	private class RemainderFunction extends Function {
		
		public RemainderFunction() {
			super("BitsOut");
			functionDelay= new Delay(10);
		} // BitsOut
		
		public Object value() {
			Iterator ti= terminals.iterator();
			boolean found= false;
			Terminal t= null;
			while (!found && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName() == SplitterGlobal.DATA_IN_TERMINAL_NAME) {
					found= true;
				}
			}
			if (found) {
				// get the data from 
				int[] bitsIn= (int[]) t.getData();
				int[] bitsOut= new int[bitsIn.length-SplitterGlobal.bitsToSplit];
				for (int i= SplitterGlobal.bitsToSplit, j=0; i< bitsIn.length; i++, j++) {
					bitsOut[j]= bitsIn[i];
				}
				return bitsOut;
			}
			else {
				director.journal("ERROR: function " + getName()
						+ " could not found terminal "
						+ SplitterGlobal.DATA_IN_TERMINAL_NAME
						+ " attached to action "
						+ SplitterAction.this.getName() + ", id= "
						+ SplitterAction.this.getID());
				director.stop();
				return null;
			}		
			
			
		} // value
		
	} // RemainderOut
	
} // SplitterAction
